Fraguel
==============================
Authors:
  - Bernardo Pericacho Sánchez
  - Alberto Guillén Álvarez
  - Gabriel Peñas Fernández
  
==============================
Abstract:

    The name FRAGUEL stands for Local Environment Guides Framework (in spanish FRAmework para GUías en Entornos Locales). As the title says, the goal of this application is to make the creation of interest points and routes between those points easy, providing a friendly and dynamic environment to access to the multimedia associated to them. There are lots of applications of user location based information, but none of them can provide routes of so different kinds (cultural, spare time, etc.) and neither of them provides the creation of that information. In fact, few of them let the user add their own content into the system. FRAGUEL application can be performed in any area with 3G or WiFi (wireless Internet through a wireless network) and GPS, and provides a mechanism for creating and sharing routes and points of interest. This is possible due to the features of the latest mobile handsets based on Android operating system. Our platform provides a way to add text, images, videos and 3D models for augmented reality. With all these tools available to users, routes can be created for tourist guides, created by friends and family about spare time, for tutorials on history and culture developed by an institution.
    
==============================
Files:
  - Fraguel.apk: application ready to be installed in Android devices with Android version 2.1 or more.
  - SSII - Proyecto FRAGUEL- 2010-2011.pdf: Documentation (in spanish). It includes an User Manual.
  - fraguel (folder): test routes (xml) & 3D objects. To be stored in the root directory of your sdcard.
  
==============================
Data:
  - allroutes.xml: file stored in the server, to be compared with your phone routes in order to download new routes.
  - exampleroute.xml: route example file to be stored in your sdcard (/sdcard/fraguel/routes/exampleroute.xml).
          <route id="2" version="1.0">
            <name>Monumentos y plazas de Madrid</name>
            <description>Madrid es la capital de España y de la Comunidad de Madrid, comunidad autónoma uniprovincial. También conocida como la Villa y Corte, es la ciudad más grande y poblada de España, alcanzando oficialmente los 3.213.271 habitantes dentro de su municipio, mientras que la cifra oficial del padrón del 1 de enero de 2009 es de 3.273.006 según el ayuntamiento y 6.043.0315 en su área metropolitana, siendo por ello la tercera ciudad más poblada de la Unión Europea (por detrás de Berlín y Londres) y la tercera área metropolitana, por detrás de las de París y Londres. \n \n Como capital del Estado, Madrid alberga las sedes del gobierno, Cortes Generales, ministerios, instituciones y organismos asociados, así como la residencia oficial de los Reyes de España. En el plano económico, Madrid es la cuarta ciudad más rica de Europa, tras Londres, París y Moscú. Es el principal centro financiero y empresarial de España,actualmente,ya que el 50,1% de los ingresos de las 5.000 principales empresas españolas son generados por sociedades con sede social en Madrid, las cuales representan el 31,8% del total. Es sede del tercer mayor mercado de valores de Europa, del segundo de ámbito latinoamericano (Latibex) y de varias de las mayores corporaciones del mundo. \n \n En el plano internacional, Madrid acoge la sede central de la Organización Mundial del Turismo (OMT), perteneciente a la Organización de las Naciones Unidas (ONU), la sede de la Secretaría General Iberoamericana (SEGIB), y la sede de la Organización de Estados Iberoamericanos para la Educación, la Ciencia y la Cultura (OEI). También alberga las principales instituciones internacionales reguladores y difusoras del idioma español: la Comisión Permanente de la Asociación de Academias de la Lengua Española, y sedes centrales de la Real Academia Española (RAE), del Instituto Cervantes y de la Fundación del Español Urgente (Fundéu). Madrid organiza ferias como FITUR, Madrid Fusión, ARCO, SIMO TCI, el Salón del Automóvil y la Cibeles Madrid Fashion Week. Madrid es un influyente centro cultural y cuenta con museos de referencia internacional entre los que destacan el Museo del Prado, sin duda uno de los más importantes del mundo, el Museo Nacional Centro de Arte Reina Sofía y el Thyssen-Bornemisza, que ocupan, respectivamente, el noveno, décimo quinto y quincuagésimo sexto puesto entre los museos más visitados del mundo. \n \n Según datos del Instituto Nacional de Estadística de 2007, su índice de desarrollo humano regional, (0.983),19 es el 2º mayor de España, y se encuentra por delante del de Noruega, el país del mundo con mayor IDH. Es además, según la revista británica Monocle, Madrid es la décima ciudad del mundo con mayor calidad de vida. \n \n Nacida a partir del asentamiento fortificado hispanomusulmán de Maǧrīţ, conquistado por Alfonso VI de León y Castilla en 1083, la villa fue designada en 1561 como sede de la corte de Felipe II, siendo la primera capital permanente de la monarquía española. Desde entonces Madrid ha sido la capital de España y sede del Gobierno de la Nación, salvo un breve intervalo de tiempo entre 1601 y 1606 en el que la capitalidad pasó temporalmente a Valladolid y durante la Guerra Civil, cuando el Gobierno se trasladó primero a Valencia y luego a Barcelona. \n \n En esta ruta, le sumergiremos en un mar de cultura visitando los puntos de interés más significativos de esta bella ciudad. Caminaremos por las plazas y calles más transitadas y turísticas de España, disfrutando de la hospitalidad y amabilidad de sus ciudadanos. ¡Disfruten de Madrid!</description>
            <icon>http://www.madridesmadrid.com/wp-content/uploads/2009/07/escudomadrid.jpg</icon>
            <points>
                <point id="0">
                    <coords x="40.418234" y="-3.710911"/>
                    <title>Teatro Real de Madrid</title>
                    <pointdescription>El Teatro Real es el teatro de la ópera de Madrid y está considerado uno de los más importantes de España y de Europa, siendo destacable la presencia habitual de la Familia Real Española en sus representaciones. Está situado en la Plaza de Oriente, frente al Palacio Real, y es uno de los monumentos más emblemáticos de la ciudad. \n \n Construcción: \n \n El rey Fernando VII promovió la construcción en Madrid de un teatro de ópera incluido dentro del proyecto de remodelación de la Plaza de Oriente. Para ello, se ordenó la demolición del antiguo Teatro de los Caños del Peral. El proyecto se encargó al arquitecto Antonio López Aguado que diseñó un edificio con forma hexagonal irregular, cuya fachada principal miraría a la Plaza de Oriente y la otra, de menor empaque, recaería sobre la actual Plaza de Isabel II. La escasez de fondos de la Casa Real impidió que las obras comenzaran antes de 1830. A la muerte del arquitecto, el proyecto fue asumido por Custodio Teodoro Moreno. Tras la subida al trono de la reina Isabel II, numerosos acontecimientos políticos y burocráticos paralizaron la ejecución del proyecto, hasta que el 7 de mayo de 1850, por medio de una Real Orden, se impulsaron las obras del Teatro, exigiendo su finalización en un plazo de seis meses. \n El Teatro se inauguró el 19 de noviembre de 1850, coincidiendo con la onomástica de la soberana. La obra elegida fue La favorita de Gaetano Donizetti y actuaron artistas de renombre, como la soprano Marietta Alboni o el director de orquesta Michele Rachele. \n En la decoración interior trabajaron los artistas y decoradores más importantes de la época como Rafael Tejeo, Eugenio Lucas, que pintó los techos, o Humanité-René Philastre, que diseñó el telón de boca. Aparte del coso teatral, con capacidad para 2.800 espectadores, había dos salones de baile, tres salones de descanso, una confitería, un café, un tocador y un guardarropa. Todas estas comodidades se habían copiado de grandes teatros europeos como el San Carlo de Nápoles o La Scala de Milán. \n \n Historia: \n \n \t 1. Primeras temporadas: \n \n Tras las pérdidas que ocasionó la primera temporada, y debido al enorme coste que tenía una representación, en torno a 1.200.000 reales y a las deudas por su construcción, el Gobierno decidió trasladar la gestión del teatro a manos privadas, mediante concesión. Durante los años sucesivos se fueron alternando diferentes empresarios privados, que solían abandonar la gestión tras sufrir enormes pérdidas. El primero fue el conocido libretista y compositor italiano Temistocle Solera. La segunda temporada se inició con la representación de Los mártires, de Donizetti. Fue una temporada breve con tan solo 69 representaciones, con gran éxito entre la aristocracia madrileña que disfrutaba con la asistencia a la ópera como la alta sociedad parisina. \n Estas primeras temporadas las dominaron las óperas de Donizetti y Bellini, con presencia también de Rossini y Verdi, que pronto se convirtió en el compositor favorito del público madrileño. La visita de Verdi al teatro, con motivo del estreno en España de su obra La forza del destino en 1863, fue todo un acontecimiento social en el Madrid de la época. A pesar de que, por contrato, los empresarios estaban obligados a presentar al menos una obra de autor español en cada temporada, normalmente se evitaba el cumplimiento de este compromiso. La primera representación de una ópera española fue el 26 de abril de 1854, con Ildegonda, de Emilio Arrieta. \n Cada uno de los ciclos tenía un promedio de 120 representaciones, la mayoría óperas, ballets y conciertos. La plantilla del teatro ascendía a 447 empleados, más los artistas que participasen en las obras concretas. Como anécdota, el joven Emilio Castelar realizó su primer gran discurso desde uno de los palcos de este teatro, en 1854. \n \n \t 2. La historia prestigiosa del Real: \n \n Los años de esplendor del Teatro Real se iniciaron en el último cuarto del siglo XIX. Se presentaron en el Teatro las voces más prestigiosas del panorama europeo, como Adela Borghi, Adelina Patti, Giulia Grisi, Christina Nilsson, Luisa Tetrazzini, Mattia Battistini, Gaetano Fraschini, Julián Gayarre, Mario de Candia, Angelo Masini, Francesco Tamagno o Enrico Tamberlick. Se produjeron representaciones memorables, como la del 23 de diciembre de 1880, en la que Patti y Gayarre cantaron Lucia di Lammermoor, de Donizetti. El propio Gayarre protagonizó uno de los episodios históricos del teatro al manifestar durante una representación de Los pescadores de perlas, en diciembre de 1889, los primeros síntomas de la pulmonía que le llevaría a la muerte un mes más tarde. \n En 1876 se representó por primera vez en el Teatro una ópera de Wagner, Rienzi, aún lejos del gran éxito que tendrían sus composiciones en este teatro quince años más tarde. En esta etapa, grandes compositores españoles como Tomás Bretón, Ruperto Chapí o Emilio Serrano puedieron ver sus obras representadas en el Real. \n \n \t 3. El Real del siglo XX: \n \n En el primer cuarto del siglo XX destacó la presencia en el Real de grandes cantantes españoles, como María Barrientos, Ofelia Nieto, Ángeles Ottein, María Gay, Miguel Fleta, Hipólito Lázaro o Francisco Viñas. También las grandes figuras líricas extranjeras (Rosina Storchio, Gabriella Besanzoni, Tito Schipa, Titta Ruffo, Giuseppe Anselmi, Giacomo Lauri-Volpi...). Dominaban el repertorio las óperas de Puccini (Tosca, La Bohème) y Wagner (Lohengrin o La valquiria). La Filarmónica de Berlín dio conciertos en el teatro, dirigida por Arthur Nikisch, en 1901 y Richard Strauss, en 1908. \n A partir de entonces, el teatro sufrió poco a poco un enorme declive, ya que a pesar de la representación de grandes óperas y la dirección de habilidosos conservadores como Andrés Coello, las crisis económico-políticas y diversos factores (incendio del teatro en 1867) causaron su ruina. Pero se volvió a levantar durante años un sólido proyecto en el que Rafael Calleja Gómez y Luis París son participes, las mejores óperas de Europa fueron traducidas y estrenadas gracias a José María Alvira, el maestro de su academia, y otros maestros y el coliseo gozó de momentos de gloria, como cuando vio pasar por su escenario al gran bailarín Nijinsky, en la que sería una de sus últimas actuaciones, en 1917, o como cuando Igor Stravinski dirigió en persona su ballet Petrushka, en el año 1921, ambos integrados en la compañía de los Ballets Rusos de Sergéi Diágilev, que visitaron el teatro varias veces, con gran éxito. El 6 de noviembre de 1925, el Teatro Real se cerró por Real Decreto, ya que corría el peligro de derrumbarse debido a las obras del Metro que se hacían en sus inmediaciones, suspendiéndose la nueva temporada que estaba a punto de iniciarse. \n \n \t 4.Reapertura como sala de conciertos: \n \n A pesar del cierre del teatro en 1925, el gobierno siempre barajó la posibilidad de remodelarlo y volverlo a abrir, creando numerosos proyectos como el que se encargó al arquitecto Antonio Flórez Urdapilleta, quien planteó una remodelación faraónica del edificio. Sin embargo, las dificultades económicas impidieron la realización de estos proyectos, que se quedaron en simples restauraciones. El teatro permaneció cerrado, y la falta de uso, y algunos incidentes, como la explosión de un polvorín que se había instalado en su interior, al final de la Guerra Civil, lo condujeron a un estado casi ruinoso. \n Tras la guerra, se planteó seriamente la demolición del edificio, mientras que la Fundación Juan March promovió la construcción de un nuevo teatro de ópera en el Paseo de la Castellana (proyecto que no llegó a hacerse realidad). Simultáneamente, se planteó la remodelación del Real como sala de conciertos, para servir de sede a la Orquesta Nacional, y como "salón de actos del Ministerio de Educación". El proyecto se encargó al arquitecto José Manuel González Valcárcel, y la reapertura se produjo en 1966, incluyendo en el edificio las instalaciones del Conservatorio de Música. Para este evento, se realizó un concierto de la Orquesta Nacional (dirigida por Rafael Frühbeck de Burgos) y el Orfeón Donostiarra al que asistieron el Jefe del Estado Francisco Franco, los príncipes Juan Carlos y Sofía, la Reina de Grecia y su hija Irene. Desde esa fecha hasta 1988 (con la apertura del Auditorio Nacional) fue la única sala de conciertos de Madrid. En 1969 acogió el XIV Festival de Eurovisión con un decorado diseñado por Salvador Dalí. \n \n El nuevo Teatro Real: \n \n De 1991 a 1997, los arquitectos José Manuel González Varcárcel y Francisco Rodríguez de Partearroyo llevaron a cabo las obras para la reconversión del Teatro en una sala operística. Se tuvo que reformar el escenario, que posee 1.430 metros cuadrados encuadrados en un arco de 18x24 metros, a lo que hay que añadir una compleja y sofisticada constitución técnica. Además, se redecoraron todos los espacios del edificio. Para la Sala Principal se mantuvo la estructura, de estilo italiano, y se recuperó la decoración original de 1850. El aforo máximo es de 1.746 localidades. \n El Teatro abrió de nuevo sus puertas el 11 de octubre de 1997, en una función de gala presidida por los Reyes de España, en la que se representaron dos obras de Manuel de Falla: el ballet El sombrero de tres picos (con los decorados y figurines originales de Pablo Picasso) y la ópera La vida breve, puesta en escena por Francisco Nieva. Ambas fueron dirigidas por el nuevo director musical del Teatro, Luis Antonio García Navarro. \n El teatro dispone, en el mismo edificio, de salas de ensayo acondicionadas para la orquesta, el coro y el cuerpo de baile, así como una sala de ensayos de escena de las mismas dimensiones del escenario principal. Los artistas cuentan con varias salas de ensayo individuales. También contiene talleres de sastrería, peluquería, caracterización, utilería y montaje de escenografías. El público dispone de restaurante, cafetería, sala de proyecciones y tienda. En 2007 se inauguró la Sala Gayarre, con 190 localidades, que se utiliza para diversas actividades complementarias, como conciertos y representaciones de ópera de cámara, recitales, actividades pedagógicas, conferencias, coloquios, cursos y proyecciones. \n Hoy en día el Real es uno de los principales teatros operísticos de Europa, cuyas temporadas acogen magníficas producciones en las que participan primeras figuras internacionales del canto, la dirección musical, la dirección de escena y la danza. Entre los mayores éxitos de esta etapa destacan los protagonizados por los tenores Juan Diego Flórez, Aquiles Machado o José Bros, los barítonos José van Dam, Leo Nucci o Carlos Álvarez, los bajos Ruggero Raimondi o Matti Salminen, las sopranos María Bayo, Inva Mula, Cecilia Bartoli, Daniela Dessì, Norah Amsellem, Violeta Urmana o Edita Gruberova, los directores Mstislav Rostropovich, Daniel Barenboim, Claudio Abbado o Valeri Gergiev y los directores de escena Giancarlo del Monaco, Pier Luigi Pizzi, Hugo de Ana o Robert Carsen. Particularmente bien acogidas han sido las apariciones del tenor madrileño Plácido Domingo, quien en una de ellas, la representación de la ópera de Verdi Simon Boccanegra, cosechó 25 minutos de aplausos por parte del público. \n Como dato curioso, cabe señalar que la única compositora que ha estrenado una ópera en el Real ha sido Pilar Jurado, el día 11 de febrero de 2011, con su obra La página en blanco. \n Desde su reapertura como teatro de ópera, la orquesta titular es la Sinfónica de Madrid. \n Actualmente, el Teatro Real acoge unas 180 funciones de ópera y ballet por temporada, además de un amplio programa de conciertos, recitales y otras actividades. El Proyecto Pedagógico, en colaboración con otros teatros madrileños presenta diferentes espectáculos relacionados con el mundo de la ópera, adaptados para niños de diferentes edades, a los que asisten centros educativos de toda España. El teatro se puede visitar diariamente, en un recorrido guiado por voluntarios de la Asociación de Amigos de la Ópera de Madrid.</pointdescription>
                    <pointicon>http://3.bp.blogspot.com/_9b_mnMgwx-k/TEh71_TdUZI/AAAAAAAAB4A/SQhfw7QhEys/s1600/Teatro+Real_Madrid_Sarah+Abilleira.jpg</pointicon>
                    <images>
                        <image url="http://sientemadrid.com/wp-content/uploads/2011/01/teatro-real-madrid.jpg">Mapa de la distribución de aforo del Teatro Real.</image>
                        <image url="http://www.cosasdemadrid.es/images/teatro_real_de_madrid_.jpg">Frontal del teatro, en el que se pueden apreciar los bellos arcos y columnas palmiformes.</image>
                        <image url="http://upload.wikimedia.org/wikipedia/commons/a/ac/Teatro_Real_(Madrid)_03.jpg">Cara frontal del Teatro Real en la que se aprecian sus atractivos y esmerados detalles arquitectónicos.</image>
                        <image url="http://www.viajejet.com/wp-content/viajes/Palco-Real-Teatro-Real-Madrid-400x300.jpg">Palco Real del Teatro Real de Madrid desde donde la Familia Real presencia las actuaciones.</image>
                        <image url="http://fotos.euroresidentes.com/fotos/Madrid/Palacio_Real_Almudena_Plaza_Mayor/images/Madrid_Teatro_Real_5.jpg">Exterior del teatro donde se aprecia parte de la plaza de Oriente.</image>
                        <image url="http://archiseek.com/wp-content/gallery/spain-madrid/TeatroReal_lge.jpg">Imagen exterior de las inmediaciones del Teatro Real.</image>
                        <image url="http://www.le-citydeluxe.com/imagenes/foto/big/AliciaKeysseconverti_1509_5307.jpg">Interior del teatro y distribución del aforo.</image>
                        <image url="http://farm2.static.flickr.com/1067/1430882192_4df0b4450e.jpg">Pintura que muestra en todo su esplendor el antiguo Teatro Real de Madrid pocos días después de su estreno.</image>
                        <image url="http://3.bp.blogspot.com/_9b_mnMgwx-k/TEh71_TdUZI/AAAAAAAAB4A/SQhfw7QhEys/s1600/Teatro+Real_Madrid_Sarah+Abilleira.jpg">Iluminación artificial del exterior del teatro por la noche.</image>
                        <image url="http://www.andreas-praefcke.de/carthalia/europe/images/e_madrid_teatroreal_2.jpg">Cuadro que retrata el antiguo Teatro Real y sus cercanías.</image>
                    </images>
                    <video>http://www.youtube.com/watch?v=3hYT7tzQOfQ</video>
                    <ar lat="0.0" long="0.0" alt="0.0" file="oso.obj,oso2.obj"/>
                </point>
            </points>
          </route>  
          
==============================
Issues:
  - probably you won't be able to download new routes because our routes and 3D objets server will not work any more.
  - you'll need to change the server link to yours:
          - class: /src/fraguel/android/states/RouteManagerState.java
          - method: public boolean onStateOptionsItemSelected(MenuItem item)
          - line: String[] url = { "http://www.blackmesa.es/fraguel/allroutes.xml" };

